/*--------------------------------------------------------------------------------------*/
/*	LZW_GIFfR[_[ <-> Susie Plug-in C^[tF[X t@C	Ver 1.00	*/
/*	for VisualStudio6.0 only															*/
/*	T|[g֐GIFwb_͕B												*/
/*	Copyright (C) 2000 DJUchi [H.Uchida]												*/
/*--------------------------------------------------------------------------------------*/
#include "SPIMain.h"
#include "GIF.h"


/*--------------------------------------------------------------------------------------*/
/*	IsSupportedEx()																		*/
/*	wb_񂩂t@C`𒲂ׂB												*/
/*	filname̓t@CŁANULLĂ邱ƂB								*/
/*	data̓t@C̃wb_ŁATCY2000oCgB									*/
/*--------------------------------------------------------------------------------------*/
BOOL IsSupportedEx(char *filename, char *data)
{
	GIFHEADER *gif_head;
	gif_head = (GIFHEADER *)data;

	if ( gif_head->signature1 == 0x38464947 ) {	//ʎq=GIF8+(7a or 9a)
		return TRUE;
	} else {
		return FALSE;
	}
}


/*--------------------------------------------------------------------------------------*/
/*	GetPictureInfoEx()																	*/
/*	摜t@C̏݁AG[R[hԂB									*/
/*	data̓t@CC[WŁATCYdatasizeoCgB								*/
/*	Aj[VGIF̏ꍇ́Aꖇڂ̉摜ԂB								*/
/*--------------------------------------------------------------------------------------*/
int GetPictureInfoEx(long datasize, struct PictureInfo *lpInfo, char *data)
{
	//O[oʋLq擾B
	GIFHEADER *gif_info;
	gif_info = (GIFHEADER *)data;

	//O[oJ[}bvGIFgubNǂݔ΂B
	char *ext_block;
	ext_block = data + sizeof(GIFHEADER);
	if ( gif_info->state & 0x80 ) ext_block += sizeof(GIFRGB) * (2 << (gif_info->state & 0x07));
	while (*ext_block == 0x21) {
		ext_block+= 2;
		while (*ext_block) {
			ext_block += *(ext_block) + 1;
		}
		ext_block++;
	}

	//ꖇڂ̃C[WLq擾B
	GIFIMAGEHEADER *gif_head;
	gif_head = (GIFIMAGEHEADER *)ext_block;

	//PictureInfo\̂ɒlԂB
	lpInfo->left		= gif_head->left;
	lpInfo->top			= gif_head->top;
	lpInfo->width		= gif_head->width;
	lpInfo->height		= gif_head->height;
	lpInfo->x_density	= 0;
	lpInfo->y_density	= 0;
	lpInfo->colorDepth	= (gif_info->state & 0x07)+1;
	//摜̃eLXgɂ́AƂ肠摜̌`iGIF87a/GIF89ajĂB
	char str[] = "GIF87a";
	if ( gif_info->signature2 == 0x6139 ) str[4]='9';//GIF89a
	HGLOBAL htxt = GlobalAlloc(GMEM_MOVEABLE, strlen(str)+1);
	char *txt = (char *)GlobalLock(htxt);
	strcpy(txt, str);
	lpInfo->hInfo		= htxt;

	return SPI_ALL_RIGHT;
}


/*--------------------------------------------------------------------------------------*/
/*	GetPictureEx()																		*/
/*	摜t@CDIBɕϊAG[R[hԂB										*/
/*	R[obN֐͖B														*/
/*	data̓t@CC[WŁATCYdatasizeoCgB								*/
/*--------------------------------------------------------------------------------------*/
int GetPictureEx(long datasize, HANDLE *pHBInfo, HANDLE *pHBm, SPI_PROGRESS, long, BYTE *data)
{
	//O[oʋLq擾B
	GIFHEADER *gif_info;
	gif_info = (GIFHEADER *)data;
	GIFRGB *gif_palette = NULL;

	//GIF̃J[rbgi8rbgȉj
	BYTE gif_color = gif_info->state & 0x07;

	//DIBwb_̈mہie|pApbg~QTUŒj 
	BITMAPINFOHEADER *bmp_head;
	bmp_head = (BITMAPINFOHEADER *)LocalAlloc
		(LMEM_FIXED, sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD)*256);
	RGBQUAD *bmp_palette;
	bmp_palette = (RGBQUAD *)(bmp_head + 1);

	//O[oJ[}bv̏
	BYTE *gif_data;
	gif_data = data + sizeof(GIFHEADER);
	if ( gif_info->state & 0x80 ) {
		gif_palette = (GIFRGB *)gif_data;
		for (int i=0; i<(2 << gif_color); i++) {
			gif_data += sizeof(GIFRGB);
			bmp_palette->rgbBlue = gif_palette->blue;
			bmp_palette->rgbGreen = gif_palette->green;
			bmp_palette->rgbRed = gif_palette->red;
			gif_palette++;
			bmp_palette++;
		}
	}

	//GIFgubNǂݔ΂B
	while (*gif_data != 0x2C) {
		gif_data+= 2;
		while (*gif_data) {
			gif_data += *(gif_data) + 1;
		}
		gif_data++;
	}

	//ꖇڂ̃C[WLq擾B
	GIFIMAGEHEADER *gif_head;
	gif_head = (GIFIMAGEHEADER *)gif_data;

	//C^[XtO
	DWORD gif_inter = gif_head->state & 0x40;

	//[JJ[}bvꍇ̏
	gif_data += sizeof(GIFIMAGEHEADER);
	if (gif_head->state & 0x80) {
		bmp_palette = (RGBQUAD *)(bmp_head + 1);
		gif_color = gif_head->state & 0x07;
		gif_palette = (GIFRGB *)gif_data;
		for (int i=0; i<(2 << gif_color); i++) {
			gif_data += sizeof(GIFRGB);
			bmp_palette->rgbBlue = gif_palette->blue;
			bmp_palette->rgbGreen = gif_palette->green;
			bmp_palette->rgbRed = gif_palette->red;
			gif_palette++;
			bmp_palette++;
		}
	}

	//DIB\́iwb_jւ̏
	bmp_head->biSize			= sizeof(BITMAPINFOHEADER);
	bmp_head->biWidth			= gif_head->width;
	bmp_head->biHeight			= gif_head->height;
	bmp_head->biPlanes			= 1;
	bmp_head->biCompression		= 0;
	bmp_head->biSizeImage		= 0;
	bmp_head->biXPelsPerMeter	= 0;
	bmp_head->biYPelsPerMeter	= 0;
	bmp_head->biClrUsed			= 0;
	bmp_head->biClrImportant	= 0;

	//DIBwb_TCYyDIBC[WTCY
	DWORD info_size;
	DWORD img_size;
	DWORD dib_align;
	//J[rbgDIBŎgpłlɋϊiI[o[Tvj
	if (gif_color == 0) {
		info_size = sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD)*2;
		dib_align = (((bmp_head->biWidth + 7) >> 3) + 3) & ~3;
		img_size = dib_align * bmp_head->biHeight;
		bmp_head->biBitCount = 1;	//PFDIB
	} else if (gif_color < 4) {
		info_size = sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD)*16;
		dib_align = (((bmp_head->biWidth + 1) >> 1) + 3) & ~3;
		img_size = dib_align * bmp_head->biHeight;
		bmp_head->biBitCount = 4;	//16FȉGIF16FDIBɋϊ
	} else if (gif_color < 8) {
		info_size = sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD)*256;
		dib_align = (bmp_head->biWidth + 3) & ~3;
		img_size = dib_align * bmp_head->biHeight;
		bmp_head->biBitCount = 8;	//256FȉGIF256FDIBɋϊ
	} else {
		return SPI_NOT_SUPPORT;
	}

	//eAvɓnDIBiwb_^C[Wj̈m
	*pHBInfo = LocalAlloc(LMEM_MOVEABLE, info_size);
	*pHBm    = LocalAlloc(LMEM_MOVEABLE, img_size);
	//mۂɎsisHj
	if (*pHBInfo == NULL || *pHBm == NULL) {
		if (*pHBInfo == NULL) LocalFree(*pHBInfo);
		if (*pHBm == NULL) LocalFree(*pHBm);
		return SPI_NO_MEMORY;
	}

	//mۂbN
	BYTE *pInfo = (BYTE *)LocalLock(*pHBInfo);
	BYTE *pBm   = (BYTE *)LocalLock(*pHBm);
	//*pHBInfoɂBITMAPINFOԋp
	memcpy(pInfo, bmp_head, info_size);

	//*pHBmɂ̓rbg}bvf[^ԋp
	//GIFWJp֐R[íIj
	GifDecode((BYTE *)pBm, gif_data, bmp_head->biWidth, bmp_head->biHeight,
		dib_align, gif_inter, bmp_head->biBitCount, (DWORD)datasize-(gif_data-data));

	//AbN
	LocalUnlock(*pHBm);
	LocalUnlock(*pHBInfo);

	//DIBwb_̈ie|pj
	LocalFree(bmp_head);

	return SPI_ALL_RIGHT;
}
